SystemOrganization addCategory: #'GT-PetitParserDebugger'!

DebugSession subclass: #GTPPDebugSession
	instanceVariableNames: 'rootParserContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPDebugSession methodsFor: 'predicates creation' stamp: 'AndreiChis 8/6/2013 17:22'!
createPredicateForBlock: aBlock 

	^ NewBlockContextPredicate for: aBlock! !

!GTPPDebugSession methodsFor: 'predicates creation' stamp: 'AndreiChis 8/5/2013 17:30'!
createStepPredicateForBlock: aBlock 

	^ self createStepPredicatForPredicate: (self createPredicatForBlock: aBlock)
			! !

!GTPPDebugSession methodsFor: 'predicates creation' stamp: 'AndreiChis 8/5/2013 17:52'!
createStepPredicateForPredicate: aPredicate 

	^ (self createPredicateForBlock: [ self isActive not ]) or: aPredicate
	! !

!GTPPDebugSession methodsFor: 'testing' stamp: 'AndreiChis 8/7/2013 19:50'!
isActive

	^ rootParserContext 
		ifNil: [ false ] 
		ifNotNil: [ 
			rootParserContext isDead not and: [
				
				rootParserContext ~= self process suspendedContext or: [rootParserContext willReturn not ]
				
				 ]  ]! !

!GTPPDebugSession methodsFor: 'testing' stamp: 'AndreiChis 8/7/2013 18:22'!
isNamedPPParser: anObject 

	^ (self isPPParser: anObject) and: [ 
		anObject name notNil ]
	! !

!GTPPDebugSession methodsFor: 'testing' stamp: 'AndreiChis 8/7/2013 18:30'!
isPPParser: anObject 

	^ self isPPParserClass: anObject class
	! !

!GTPPDebugSession methodsFor: 'testing' stamp: 'AndreiChis 8/7/2013 14:24'!
isPPParserClass: aClass

	^ aClass inheritsFrom: PPParser 

	! !

!GTPPDebugSession methodsFor: 'predicates' stamp: 'AndreiChis 8/7/2013 20:25'!
namedProductionPredicate: anObject
	""
	
	^ self createPredicateForBlock: [ :aContext |
		(self isNamedPPParser: aContext receiver) and: [ 
			anObject isNil or: [ 
				aContext receiver name = anObject ] ] ]! !

!GTPPDebugSession methodsFor: 'debugging actions' stamp: 'AndreiChis 8/5/2013 17:51'!
newStepUntil: aPredicate from: aContext 

	^ super 
		newStepUntil: (self createStepPredicateForPredicate: aPredicate) 
		from: aContext ! !

!GTPPDebugSession methodsFor: 'predicates' stamp: 'AndreiChis 8/7/2013 18:45'!
notDelegateParserClassPredicate

	^ self createPredicateForBlock: [ :aContext |
		(self isPPParser: aContext receiver) and: [ 
			aContext receiver class ~= PPDelegateParser ] ]! !

!GTPPDebugSession methodsFor: 'predicates' stamp: 'AndreiChis 8/7/2013 18:29'!
parseMethodEntryPredicate

	^ self createPredicateForBlock: [ :aContext |
			(self isPPParser: aContext receiver) and: [ 
				aContext selector = #parseOn: and: [ 
					aContext isInitialnstruction ] ] ]! !

!GTPPDebugSession methodsFor: 'predicates' stamp: 'AndreiChis 8/7/2013 18:29'!
parseMethodPredicate

	^ self createPredicateForBlock: [ :aContext |
			(self isPPParser: aContext receiver) and: [ 
				aContext selector = #parseOn: ] ]! !

!GTPPDebugSession methodsFor: 'initialization' stamp: 'AndreiChis 7/17/2013 23:09'!
process: aProcess context: aContext

	super process: aProcess context: aContext.
	
	self flag: 'Have a method that is only called when the session is created and put this there'.
	rootParserContext ifNil:  [
		rootParserContext := aContext locateRootPPParser]! !

!GTPPDebugSession methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 13:57'!
rootParser

	^ rootParserContext receiver! !

!GTPPDebugSession methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 18:24'!
rootParserContext

	^ rootParserContext! !

!GTPPDebugSession methodsFor: 'debugging actions' stamp: 'AndreiChis 7/17/2013 22:53'!
stepOverInitialInstructionForContext: aContext
	
	(self isActive and: [
		self parseMethodEntryPredicate matches: aContext ])  
			ifTrue: [ self stepInto ]
	! !

!GTPPDebugSession methodsFor: 'debugging actions' stamp: 'AndreiChis 8/5/2013 17:37'!
stepToNextNonDelegateParserFromContext: aContext

	self 
		newStepUntil: (self parseMethodEntryPredicate and: self notDelegateParserClassPredicate)
		from: aContext! !

!GTPPDebugSession methodsFor: 'debugging actions' stamp: 'AndreiChis 8/7/2013 18:51'!
stepToNextParserFromContext: aContext

	self 
		newStepUntil: self parseMethodEntryPredicate
		from: aContext! !

!GTPPDebugSession methodsFor: 'debugging actions' stamp: 'AndreiChis 8/7/2013 20:25'!
stepToNextProduction: aProduction fromContext: aContext
	
	self 
		newStepUntil: (self parseMethodEntryPredicate and: (self namedProductionPredicate: aProduction)) 
		from: aContext! !

!GTPPDebugSession methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 11:30'!
stream

	^ self streamFromContext: rootParserContext! !

!GTPPDebugSession methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 11:30'!
streamFromContext: aContext

	^ aContext tempAt: 1! !

!MethodContext methodsFor: '*GT-PetitParserDebugger' stamp: 'AndreiChis 8/6/2013 18:08'!
locateRootPPParser
	"Find the last context starting from the top of the stack (or the first starting from the bottom of the stack)
	that was created by a PPParser"
	| parserContext currentContext |

	parserContext := nil.
	currentContext := self.
	[ 
		(currentContext := currentContext locateTopPPParser) notNil
	 ] whileTrue: [ 
		parserContext := currentContext.
		currentContext := currentContext sender ].

	^ parserContext! !

!MethodContext methodsFor: '*GT-PetitParserDebugger' stamp: 'AndreiChis 8/7/2013 17:57'!
locateTopNamedPPParser
	
	^ (self findContextSuchThat:  [ :ctx | 
			(ctx receiver class inheritsFrom: PPParser) and: [ 
				ctx selector = #parseOn: and: [ 
					ctx receiver name notNil ] ] ])
	
	
! !

!MethodContext methodsFor: '*GT-PetitParserDebugger' stamp: 'AndreiChis 8/6/2013 18:07'!
locateTopPPParser
	"Find the first context, starting from the top the stack that was created by a PPParser. "
	
	^ (self findContextSuchThat:  [ :ctx | 
			(ctx receiver class inheritsFrom: PPParser) and: [ ctx selector = #parseOn: ] ])
	
	
! !

GTDebugger subclass: #GTPPDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 7/15/2013 16:34'!
defaultTitle

	^ 'PetitParser Debugger'! !

!GTPPDebugger class methodsFor: 'testing' stamp: 'AndreiChis 8/6/2013 18:01'!
handlesContext: aContext

	^ aContext locateTopPPParser notNil ! !

!GTPPDebugger class methodsFor: 'tools registry' stamp: 'AndreiChis 7/15/2013 16:40'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 
	registry registerDebugger: self withRank: 55.! !

!GTPPDebugger class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/17/2013 23:05'!
sessionClass

	^ GTPPDebugSession ! !

!GTPPDebugger methodsFor: 'building' stamp: 'AndreiChis 8/7/2013 12:03'!
debuggerStructureIn: browser
	
	browser
		row: [ :row | 
					row
						column: #stack span: 2;
						column: [ :column |
							column 
								row: [ :row2 | 
									row2
										column: #code;
										column: #stream ];
								row: #workspace ] span: 3 ];
		row: #inspector.! !

!GTPPDebugger methodsFor: 'building' stamp: 'AndreiChis 8/8/2013 12:14'!
debuggerTransmissionsIn: browser

	super debuggerTransmissionsIn: browser.
	
	browser transmit
		from: #stack port: #entity;
		to: #stream;
		when: [ :aSession | aSession notNil ];
		andShow: [ :aComposite | self streamIn: aComposite ].
		
	browser transmit
		from: #stack port: #entity;
		from: #stack port: #selection;
		to: #workspace;
		when: [ :aSession :aContext | aSession notNil & aContext notNil ];
		andShow: [ :aComposite :aSession :aContext | self workspaceIn: aComposite forSession: aSession forContext: aContext ].
	! !

!GTPPDebugger methodsFor: 'building actions' stamp: 'AndreiChis 7/16/2013 23:41'!
debuggingActionsPragmas

	^ super debuggingActionsPragmas, { #PPDebuggingAction }! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 8/7/2013 18:01'!
exampleIn: aComposite forSession: aSession forPoduction: aProduction

	aComposite text
		title: 'Example';
		useExplicitNotNil;
		display: [ (self production: aProduction from: aSession rootParser class) example ];
		act: [:text | text update] icon: GLMUIThemeExtraIcons glamorousRefresh entitled: 'Generate another one'! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 8/7/2013 18:01'!
firstIn: aComposite forSession: aSession forPoduction: aProduction

	aComposite list
		title: 'First';
		useExplicitNotNil;
		display: [ (self production: aProduction from: aSession rootParser class) firstSet ];
		format: [ :parser | parser displayName ]! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 8/7/2013 18:01'!
followIn: aComposite forSession: aSession forPoduction: aProduction
	
	aComposite list
		title: 'Follow';
		useExplicitNotNil;
		format: [ :parser | parser displayName ];
		display: [
			| parser |
			parser := aSession rootParser class new.
			parser followSets
				at: (parser productionAt: aProduction)
				ifAbsent: [ Array with: nil asParser ] ]! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 8/7/2013 17:46'!
graphIn: aComposite forSession: aSession forPoduction: aProduction
	
	aComposite morph
		title: 'Graph';
		useExplicitNotNil;
		display: [ 
			| morph |
			morph := ScrollPane new.
			morph color: Color white.
			morph scroller addMorph: (self production: aProduction from: aSession rootParser class) morphicProduction.
			morph ] ! !

!GTPPDebugger methodsFor: 'building actions' stamp: 'AndreiChis 8/8/2013 11:57'!
installStreamActionsFor: aPresentation

	self installActionsForRootPragmas: { #PPStreamDebuggingAction } in: aPresentation! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 8/7/2013 18:03'!
mapIn: aComposite forSession: aSession forPoduction: aProduction

	self class environment at: #GLMRoassalPresentation ifPresent: [ :cls |
		aComposite roassal
			title: 'Map';
			useExplicitNotNil;
			painting: [ :view |
				(self production: #start from: aSession rootParser class)
					viewAllNamedParsersWithSelection: (Array with: aProduction)
					previewing: [:eachParser | self sourceCodeFrom: aSession rootParser class selector: eachParser name ]
					on: view ] ]	
! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 8/7/2013 18:20'!
printStackEntry: aContext

	^ Text 
		string: (self printStackEntryStringFor: aContext )
		attributes: (self textAttributesForStackEntry: aContext) 
	! !

!GTPPDebugger methodsFor: 'private utilities' stamp: 'AndreiChis 8/7/2013 18:19'!
printStackEntryStringFor: aContext

	^ (self session isPPParser: aContext receiver)
		ifTrue: [ 
			String streamContents: [:stream | 
				| str |
				
				stream nextPutAll: aContext receiver class name.
				aContext methodClass == aContext receiver class 
					ifFalse: [
						stream nextPut: $(.
						stream nextPutAll: aContext methodClass name.
						stream nextPut: $) ].
				stream nextPut: $(.
				aContext receiver printNameOn: stream.
				stream nextPut: $).
				stream nextPutAll: '>>'.
				
				str := super printStackEntry: aContext.
				str := str allButFirst: (str indexOf: '>' ifAbsent: [ -1 ]) + 1.
				stream nextPutAll: str ]  ]
		ifFalse: [ super printStackEntry: aContext ]
	! !

!GTPPDebugger methodsFor: 'private utilities' stamp: 'AndreiChis 8/7/2013 14:03'!
production: selector from: class
	| parser |
	
	parser := class new.
	^ selector isNil 
		ifTrue: [ parser ]
		ifFalse: [ parser productionAt: selector ]! !

!GTPPDebugger methodsFor: 'private utilities' stamp: 'AndreiChis 8/7/2013 19:14'!
productionSelectorsFrom: class

	^ (((class allInstVarNames copyWithoutAll: class ignoredNames)
		collect: [ :each | each asSymbol ])
			select: [ :each | class includesSelector: each ]) asSortedCollection add: #start; yourself! !

!GTPPDebugger methodsFor: 'private utilities' stamp: 'AndreiChis 8/7/2013 14:05'!
sourceCodeFrom: class selector: production

	^ class ultimateSourceCodeAt: (production ifNil: [ #start ]) ifAbsent: [ String new ]! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 8/7/2013 17:58'!
sourceIn: aComposite forSession: aSession forPoduction: aProduction

	aComposite smalltalkCode
		title: 'Source';
		useExplicitNotNil;
		display: [ self sourceCodeFrom: aSession rootParser class selector: aProduction ];
		smalltalkClass: [ aSession rootParser class ]! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 8/8/2013 12:13'!
streamIn: composite
	
	composite text
		title: 'Stream';
		when: [ :aSession | aSession stream notNil ];
		format: [ :aSession | aSession stream collection ];
		initialize: [ :aPresentation | aPresentation 
			selectionInterval: (1 to: (self session stream ifNil: [ 0 ] ifNotNil: [ :aStream | aStream position ])) ];
		with: [ :aPresentation | self installStreamActionsFor: aPresentation ]! !

!GTPPDebugger methodsFor: 'accessing' stamp: 'AndreiChis 8/8/2013 11:49'!
streamPane

	^ self browser paneNamed: #stream! !

!GTPPDebugger methodsFor: 'accessing' stamp: 'AndreiChis 8/8/2013 11:51'!
streamSelectionInterval

	^ self selectionIntervalForPane: #stream! !

!GTPPDebugger methodsFor: 'private utilities' stamp: 'AndreiChis 8/7/2013 18:53'!
textAttributesForStackEntry: aContext

	(self session isNamedPPParser: aContext receiver) 
		ifTrue: [ ^ {TextEmphasis bold} ].
		
	(self session rootParserContext  == aContext )
		ifTrue: [ ^ {TextEmphasis italic} ].
		
	^ {TextColor black}! !

!GTPPDebugger methodsFor: 'updating' stamp: 'AndreiChis 8/8/2013 11:49'!
updateStreamSelectionInterval

	(self streamPane port: #selectionInterval) value: (1 to: self session stream position)! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 8/7/2013 18:00'!
workspaceIn: aComposite forSession: aSession forContext: aContext
	| targetParser nameProperty |
	
	targetParser := (aContext locateTopNamedPPParser) 
		ifNil: [ aSession rootParser ] 
		ifNotNil: [ :parserContext | parserContext receiver ].
	nameProperty := targetParser propertyAt: 'name' ifAbsent: [ nil ].
	
	self sourceIn: aComposite forSession: aSession forPoduction: nameProperty.
	self graphIn: aComposite forSession: aSession forPoduction: nameProperty.
	self mapIn: aComposite forSession: aSession forPoduction: nameProperty.
	self exampleIn: aComposite forSession: aSession forPoduction: nameProperty.
	self firstIn: aComposite forSession: aSession forPoduction: nameProperty.
	self followIn: aComposite forSession: aSession forPoduction: nameProperty.! !

DebugAction subclass: #GTPPDebugAction
	instanceVariableNames: 'startContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPDebugAction methodsFor: 'testing' stamp: 'AndreiChis 8/6/2013 18:01'!
appliesToContext: aContext

	^ self session isActive and: [
		aContext locateTopPPParser notNil ]! !

!GTPPDebugAction methodsFor: 'accessing' stamp: 'AndreiChis 8/6/2013 14:18'!
startContext

	^ startContext ifNil: [ self currentContext ]! !

!GTPPDebugAction methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2013 23:33'!
startContext: aContext

	startContext := aContext! !

GTPPDebugAction subclass: #GTPPStepToNextNamedProductionAction
	instanceVariableNames: 'production'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToNextNamedProductionAction class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/7/2013 23:46'!
gtToNextProductionActionFor: aDebugger
	<gtPPDebuggingAction>
	<gtContextPPDebuggingAction>

	^ self new 
		production: nil;
		label: 'named parser';
		category: 'Next parser invocation';
		order: 26! !

!GTPPStepToNextNamedProductionAction class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/7/2013 20:04'!
gtToProductionActionFor: aDebugger
	<gtPPDebuggingAction>
	<gtContextPPDebuggingAction>
	| order |
	
	order := 40.
	^ (aDebugger productionSelectorsFrom: aDebugger session rootParser class) collect: [ :aProduction |
		self new 
			production: aProduction;
			label: aProduction asString;
			category: 'Next production';
			order: (order := order + 1) ]! !

!GTPPStepToNextNamedProductionAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 23:06'!
defaultProduction

	^ nil! !

!GTPPStepToNextNamedProductionAction methodsFor: 'actions' stamp: 'AndreiChis 8/7/2013 19:00'!
executeAction
	
	self session 
		stepOverInitialInstructionForContext: self startContext;
		stepToNextProduction: self production fromContext: self startContext! !

!GTPPStepToNextNamedProductionAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 18:59'!
production
	
	^ production! !

!GTPPStepToNextNamedProductionAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 18:59'!
production: anObject
	
	production := anObject! !

GTPPStepToNextNamedProductionAction subclass: #GTPPStepToSameNamedProductionAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToSameNamedProductionAction class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/7/2013 23:21'!
gtActionType
	<gtPPDebuggingAction>
	<gtContextPPDebuggingAction>

	! !

!GTPPStepToSameNamedProductionAction methodsFor: 'testing' stamp: 'AndreiChis 8/7/2013 23:02'!
appliesToContext: aContext

	^ (super appliesToContext: aContext) and: [ 
		self session isNamedPPParser: aContext receiver ]! !

!GTPPStepToSameNamedProductionAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 23:21'!
defaultCategory

	^ 'Next parser invocation'! !

!GTPPStepToSameNamedProductionAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 23:20'!
defaultLabel

	^ 'same production'! !

!GTPPStepToSameNamedProductionAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 23:18'!
defaultOrder

	^ 31! !

!GTPPStepToSameNamedProductionAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 23:17'!
defaultProduction

	^ self currentContext receiver name! !

GTPPDebugAction subclass: #GTPPStepToNextNonDelegateParserAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToNextNonDelegateParserAction class methodsFor: 'registration' stamp: 'AndreiChis 8/7/2013 18:33'!
gtActionType
	<gtPPDebuggingAction>
	<gtContextPPDebuggingAction>! !

!GTPPStepToNextNonDelegateParserAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 20:28'!
defaultCategory
	
	^ 'Next parser invocation'! !

!GTPPStepToNextNonDelegateParserAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 20:29'!
defaultLabel 
	
	^ 'non-delegate parser'! !

!GTPPStepToNextNonDelegateParserAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 23:19'!
defaultOrder

	^ 27! !

!GTPPStepToNextNonDelegateParserAction methodsFor: 'actions' stamp: 'AndreiChis 8/5/2013 17:37'!
executeAction	

	self session 
		stepOverInitialInstructionForContext: self startContext;
		stepToNextNonDelegateParserFromContext: self startContext
! !

GTPPDebugAction subclass: #GTPPStepToNextParserAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToNextParserAction class methodsFor: 'registration' stamp: 'AndreiChis 8/7/2013 18:33'!
gtActionType
	<gtPPDebuggingAction>
	<gtContextPPDebuggingAction>! !

!GTPPStepToNextParserAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 20:30'!
defaultCategory

	^ 'Next parser invocation'! !

!GTPPStepToNextParserAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 20:29'!
defaultLabel 

	^ 'any parser'! !

!GTPPStepToNextParserAction methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2013 22:59'!
defaultOrder

	^ 25! !

!GTPPStepToNextParserAction methodsFor: 'actions' stamp: 'AndreiChis 8/5/2013 17:12'!
executeAction
	
	self session 
		stepOverInitialInstructionForContext: self startContext;
		stepToNextParserFromContext: self startContext! !

GTPPDebugAction subclass: #GTPPStepToParserTypeAction
	instanceVariableNames: 'parserClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToParserTypeAction class methodsFor: 'registration' stamp: 'AndreiChis 8/7/2013 23:42'!
gtActionFor: aDebugger
	<gtPPDebuggingAction>
	<gtContextPPDebuggingAction>
	|order|
	
	order := 50.
	^ self parserTypes collect: [ :each |
		self new
			parserClass: each;
			label: each name;
			category: 'Next type';
			order: (order := order + 1) ]! !

!GTPPStepToParserTypeAction class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/7/2013 23:41'!
parserTypes

	^ { 
		PPDelegateParser. 
		PPActionParser. 
		PPWrappingParser. 
		PPAndParser. 
		PPEndOfInputParser. 
		PPFlattenParser. 
		PPTokenParser. 
		PPMemoizedParser. 
		PPNotParser. 
		PPOptionalParser. 
		PPGreedyRepeatingParser. 
		PPLazyRepeatingParser. 
		PPPossessiveRepeatingParser. 
		PPTrimmingParser. 
		PPEpsilonParser. 
		PPFailingParser. 
		PPChoiceParser. 
		PPSequenceParser. 
		PPLiteralObjectParser. 
		PPLiteralSequenceParser. 
		PPPluggableParser. 
		PPPredicateObjectParser. 
		PPPredicateSequenceParser
	}! !

!GTPPStepToParserTypeAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 23:52'!
defaultParserClass

	^ nil! !

!GTPPStepToParserTypeAction methodsFor: 'actions' stamp: 'AndreiChis 8/6/2013 14:26'!
executeAction

	self session
		stepOverInitialInstructionForContext: self startContext;
		newStepUntil: self sameParserTypePredicate from: self startContext.! !

!GTPPStepToParserTypeAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 23:52'!
parserClass

	^ parserClass ifNil: [ self defaultParserClass ]! !

!GTPPStepToParserTypeAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 23:37'!
parserClass: aClass 

	parserClass := aClass! !

!GTPPStepToParserTypeAction methodsFor: 'predicates' stamp: 'AndreiChis 8/7/2013 23:37'!
sameParserClassPredicate

	^ self session createPredicateForBlock: [ :aContext |
		aContext receiver class == self parserClass ]! !

!GTPPStepToParserTypeAction methodsFor: 'predicates' stamp: 'AndreiChis 8/6/2013 14:27'!
sameParserTypePredicate

	^ self session parseMethodEntryPredicate and: self sameParserClassPredicate! !

GTPPStepToParserTypeAction subclass: #GTPPStepToSameParserTypeAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToSameParserTypeAction class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/8/2013 00:15'!
gtActionType
	<gtPPDebuggingAction>
	<gtContextPPDebuggingAction>! !

!GTPPStepToSameParserTypeAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/7/2013 23:43'!
appliesToContext: aContext

	^ (super appliesToContext: aContext) and: [ 
		aContext receiver class inheritsFrom: PPParser ]! !

!GTPPStepToSameParserTypeAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/7/2013 23:47'!
defaultCategory

	^ 'Next parser invocation'! !

!GTPPStepToSameParserTypeAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/7/2013 23:47'!
defaultLabel 

	^ 'same class'! !

!GTPPStepToSameParserTypeAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/7/2013 23:47'!
defaultOrder

	^ 32! !

!GTPPStepToSameParserTypeAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/7/2013 23:53'!
defaultParserClass

	^ self currentContext receiver class! !

GTPPDebugAction subclass: #GTPPStepToSameParserAction
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToSameParserAction class methodsFor: 'registration' stamp: 'AndreiChis 8/6/2013 17:45'!
gtActionFor: aDebugger
	<gtPPDebuggingAction>
	<gtContextPPDebuggingAction>
	
	^ self new
		parser: aDebugger currentContext receiver! !

!GTPPStepToSameParserAction methodsFor: 'testing' stamp: 'AndreiChis 7/17/2013 23:39'!
appliesToContext: aContext

	^ (super appliesToContext: aContext) and: [ 
		aContext receiver class inheritsFrom: PPParser ]! !

!GTPPStepToSameParserAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 20:30'!
defaultCategory

	^ 'Next parser invocation'! !

!GTPPStepToSameParserAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 20:30'!
defaultLabel 

	^ 'same parser'! !

!GTPPStepToSameParserAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 23:17'!
defaultOrder

	^ 30! !

!GTPPStepToSameParserAction methodsFor: 'actions' stamp: 'AndreiChis 8/5/2013 17:41'!
executeAction

	self session
		stepOverInitialInstructionForContext: self startContext;
		newStepUntil: self sameParserPredicate from: self startContext.! !

!GTPPStepToSameParserAction methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2013 16:40'!
parser

	^ parser! !

!GTPPStepToSameParserAction methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2013 16:40'!
parser: anObject

	parser := anObject! !

!GTPPStepToSameParserAction methodsFor: 'predicates' stamp: 'AndreiChis 8/6/2013 14:10'!
sameParserObjectPredicate

	^ self session createPredicateForBlock: [ :aContext |
		aContext receiver == self parser ]! !

!GTPPStepToSameParserAction methodsFor: 'predicates' stamp: 'AndreiChis 8/5/2013 17:41'!
sameParserPredicate

	^ self session parseMethodEntryPredicate and: self sameParserObjectPredicate! !

GTPPDebugAction subclass: #GTPPStepToStreamPositionAction
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToStreamPositionAction class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/8/2013 12:03'!
gtNextStreamUpdateAction
	<gtPPStreamDebuggingAction>
	<gtContextPPStreamDebuggingAction>
	
	^ self new
		label: 'Run to next update';
		icon: GLMUIThemeExtraIcons glamorousInto! !

!GTPPStepToStreamPositionAction class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/8/2013 12:03'!
gtSelectedStreamPositionActionFor: aDebugger
	<gtPPStreamDebuggingAction>
	<gtContextPPStreamDebuggingAction>
	
	^ self new
		position: aDebugger streamSelectionInterval last;
		label: 'Run to here'! !

!GTPPStepToStreamPositionAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/8/2013 11:55'!
executeAction
	| currentPosition targetPosition |

	currentPosition := self session stream position.
	targetPosition := self position 
		ifNil: [ currentPosition + 1 ]
		ifNotNil: [ :anInteger | anInteger ].
"	targetPosition <= currentPosition ifTrue: [
		targetPosition := currentPosition + 1 ]."
		
	self session
		newStepUntil: (self streamToPosition: targetPosition) from: self startContext.! !

!GTPPStepToStreamPositionAction methodsFor: 'accessing' stamp: 'AndreiChis 8/8/2013 11:24'!
position
	
	^ position! !

!GTPPStepToStreamPositionAction methodsFor: 'accessing' stamp: 'AndreiChis 8/8/2013 11:30'!
position: anInteger
	
	position := anInteger! !

!GTPPStepToStreamPositionAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/8/2013 11:31'!
streamToPosition: anInteger

	^ self session createPredicateForBlock: [
		self session stream position >= anInteger ]! !

GTPPDebugAction subclass: #GTPPWhereIsStreamAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPWhereIsStreamAction class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/8/2013 11:45'!
gtActionType
	<gtPPStreamDebuggingAction>! !

!GTPPWhereIsStreamAction methodsFor: 'accessing' stamp: 'AndreiChis 8/8/2013 11:36'!
defaultIcon
	
	^ GLMUIThemeExtraIcons glamorousSearch! !

!GTPPWhereIsStreamAction methodsFor: 'accessing' stamp: 'AndreiChis 8/8/2013 11:36'!
defaultLabel 
	
	^ 'Where is stream?'! !

!GTPPWhereIsStreamAction methodsFor: 'actions' stamp: 'AndreiChis 8/8/2013 11:42'!
executeAction

	self debugger updateStreamSelectionInterval! !
